﻿# -*- coding: utf-8 -*-


def Login(self, start_new_instance=True):
    """
    When application is not open:
    Register the application instance at current computer, login to
    registration file and start the FileObserver. Returns True

    When all allow application instances are running:
    Returns False

    start_new_instance = if False, allways block to starts a new instance
    """
    apptree = self._ReadRegFile()
    running_pids = self._get_running_pids(apptree)

    # if regfile reading failed, disallow starting a new instance
    if hasattr(apptree, "openId") and apptree.openId == ID_OPEN_BREAK:
        return False

    # set new application instance
    elif len(running_pids) < self.num_of_instances and start_new_instance:
        # login to registration files
        self._set_instance_data(apptree, self.pid)
        self._UpdateRegFile(apptree, False)

        # registrate exit function
        atexit.register(self._closeFileObserver)

        # start file server
        fobs = FileObserver(self, self.pid, self.regfile,
            self.app_globals, self.app_locals)
        fobs.daemon = True
        fobs.start()
        return True

    # disallow existing application instance
    else:
        return False
